; Program for an Electronic Dice
; 
; Program executed on 89C2051 24PI microcontroller
; XTAL - 18MHz

P1 EQU 090H
P3 EQU 0B0H

TCON EQU 088H
TMOD EQU 089H
TL0 EQU 08AH
TH0 EQU 08cH
IE EQU 0A8H

org 0000h
	ajmp start

org 0003h
	acall INT0
	reti

org 0050h
start:
	clr P3.7
	clr P1.2
	clr P1.3
	clr P1.4
	clr P1.5
	clr P1.6
	clr P1.7
	mov TH0, #000H
	mov TL0, #000H
	mov TMOD, #00000010b
	mov TCON, #00010001b
	mov IE, #10000001b
loop:
	nop
	nop
	nop
	ajmp loop

INT0:
	mov IE, #00000000b
	mov A, TL0
	anl A, #007H
	cjne A, #000H, DISP1
	ajmp DISP0
DISP1:
	cjne A, #001H, DISP2
DISP0:	
	setb P3.7
	clr P1.2
	clr P1.3
	clr P1.4
	clr P1.5
	clr P1.6
	clr P1.7
	ajmp correct
DISP2:
	cjne A, #002H, DISP3
	clr P3.7
	clr P1.2
	setb P1.3
	clr P1.4
	clr P1.5
	setb P1.6
	clr P1.7
	ajmp correct
DISP3:
	cjne A, #003H, DISP4
	setb P3.7
	clr P1.2
	setb P1.3
	clr P1.4
	clr P1.5
	setb P1.6
	clr P1.7
	ajmp correct
DISP4:
	cjne A, #004H, DISP5
	clr P3.7
	setb P1.2
	clr P1.3
	setb P1.4
	setb P1.5
	clr P1.6
	setb P1.7
	ajmp correct
DISP5:
	cjne A, #005H, DISP6
	setb P3.7
	setb P1.2
	clr P1.3
	setb P1.4
	setb P1.5
	clr P1.6
	setb P1.7
	ajmp correct
DISP6:
	clr P3.7
	setb P1.2
	setb P1.3
	setb P1.4
	setb P1.5
	setb P1.6
	setb P1.7

correct:
	mov TH0, #000H
	mov TL0, #000H
	mov TMOD, #00000010b
	mov TCON, #00010001b
	mov IE, #10000001b
	ret

END